'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createNewConstructorTransform;

var _package = require('../../package.json');

var _createImport = require('./createImport');

var _createImport2 = _interopRequireDefault(_createImport);

var _isPolyfillPath = require('./isPolyfillPath');

var _isPolyfillPath2 = _interopRequireDefault(_isPolyfillPath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createNewConstructorTransform(className) {
  return {
    NewExpression(path, { file }, { types: t }) {
      const { filename } = file.opts;
      if ((0, _isPolyfillPath2.default)(filename)) {
        return;
      }

      if (path.node.callee.name !== className) {
        return;
      }

      const identifier = (0, _createImport2.default)(file, `_create_${className}`, `${_package.name}/polyfills/${className}`);

      path.replaceWith(t.callExpression(identifier, path.node.arguments));
    }
  };
}